Imports DotNetNuke
Imports DotNetNuke.Entities.Portals
Imports System.Web
Imports System.Threading
Imports System.IO


Namespace DGZfP.EventPublisher
    Public MustInherit Class ControllerBase
        Private _moduleSettings As Hashtable
        Private _moduleId As Integer
        Private _portalId As Integer
        Private _portalInfo As DotNetNuke.Entities.Portals.PortalInfo

        Public ReadOnly Property Settings() As Hashtable
            Get
                If Not _moduleSettings Is Nothing Then
                    Return _moduleSettings
                Else
                    Dim mc As New Entities.Modules.ModuleController()
                    Return mc.GetModuleSettings(ModuleID)
                End If

            End Get
        End Property


        Private ReadOnly Property PortalSettings() As Entities.Portals.PortalSettings
            Get
                Return PortalController.GetCurrentPortalSettings()
            End Get
        End Property

        Public ReadOnly Property PortalInfo() As DotNetNuke.Entities.Portals.PortalInfo
            Get
                If _portalInfo Is Nothing Then
                    _portalInfo = New PortalController().GetPortal(PortalId)
                End If
                Return _portalInfo
            End Get

        End Property

        Public Property ModuleID() As Integer
            Get
                Return _moduleId
            End Get
            Set(ByVal Value As Integer)
                _moduleId = Value
            End Set
        End Property


        Protected Property PortalId() As Integer
            Get
                Return _portalId
            End Get
            Set(ByVal value As Integer)
                _portalId = value
            End Set
        End Property

        Protected ReadOnly Property AdministratorId() As String
            Get
                If Not (HttpContext.Current Is Nothing) Then
                    Return PortalSettings.AdministratorId
                Else
                    Return PortalInfo.AdministratorId
                End If
            End Get
        End Property


        Public Sub Initialise(ByVal parent As DotNetNuke.Entities.Modules.PortalModuleBase)
            _moduleSettings = parent.Settings
            ModuleID = parent.ModuleId
            PortalId = parent.PortalId
        End Sub

        Public Sub Initialise(ByVal ModuleInfo As DotNetNuke.Entities.Modules.ModuleInfo)
            ModuleID = ModuleInfo.ModuleID
            PortalId = ModuleInfo.PortalID
        End Sub

    End Class
End Namespace

